//  Copyright (c) 2012 Dennco Project
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

//
//  Created by tkawata on Apr/15/2012.
//
#include "DNServerSerialPort.h"

#include "DNEngine.h"

DNServerSerialPort::DNServerSerialPort(DNEngine *engine) : DNServerBase(engine)
{
    m_serialPort = new DNSerialPort(this);
}

DNServerSerialPort::~DNServerSerialPort()
{
    if (m_serialPort)
    {
        m_serialPort->stop();
        delete m_serialPort;
        m_serialPort = NULL;
    }
}

bool DNServerSerialPort::isRunning()
{
    if (m_serialPort)
    {
        return m_serialPort->isRunning();
    }
    return false;
}

bool DNServerSerialPort::setup()
{
    if (m_serialPort)
    {
        return m_serialPort->setup();
    }
    return false;
}

void DNServerSerialPort::start()
{
    if (m_serialPort)
    {
        m_serialPort->start();
    }
}

void DNServerSerialPort::stop()
{
    if (m_serialPort)
    {
        m_serialPort->stop();
    }
}

void DNServerSerialPort::doQueryRequest(std::string requestBody)
{

}

void DNServerSerialPort::doSetRequest(std::string requestBody)
{
}
